unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

function ReadProcPChar(WindowCaption : String; Address : Pointer) : String;
var
  Wnd : Hwnd;
  ph,pid : dword;
  BytesRead : Cardinal;
  c:char;
begin
  Result := '';
  Wnd := FindWindow(nil,pchar(WindowCaption));
  if Wnd = 0 then
    exit;
  GetWindowThreadProcessID(Wnd, @pid);
  ph := OpenProcess(PROCESS_ALL_ACCESS, false, pid);
  if ph=INVALID_HANDLE_VALUE then
    exit;
  try
    repeat
      if not ReadProcessMemory(ph, Address, @c, 1, BytesRead) then
        raise exception.create(syserrormessage(getlasterror));
      result:=result+c;
      Address:=pointer(integer(address)+1);
    until (c=#0) or (BytesRead<>1);
  finally
    CloseHandle(ph);
  end;
end;

function ReadProcString(WindowCaption : String; Address : Pointer) : String;
var
  Wnd : Hwnd;
  ph,pid : dword;
  BytesRead : Cardinal;
  s:pchar;
  c:char;
begin
  Result := '';
  Wnd := FindWindow(nil,pchar(WindowCaption));
  if Wnd = 0 then
    exit;
  GetWindowThreadProcessID(Wnd, @pid);
  ph := OpenProcess(PROCESS_ALL_ACCESS, false, pid);
  if ph=INVALID_HANDLE_VALUE then
    exit;
  try
    if not ReadProcessMemory(ph, Address, @s, 4, BytesRead) then
      raise exception.create(syserrormessage(getlasterror));
    Address:=s;;
    result:='';
    repeat
      if not ReadProcessMemory(ph, Address, @c, 1, BytesRead) then
        raise exception.create(syserrormessage(getlasterror));
      result:=result+c;
      Address:=pointer(integer(address)+1);
    until (c=#0) or (BytesRead<>1);
  finally
    CloseHandle(ph);
  end;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  edit1.text:=ReadProcPChar('Form1', pointer(strtoint(edit1.text)));
  edit2.text:=ReadProcString('Form1', pointer(strtoint(edit2.text)));
end;

end.
